<template>
<v-col cols='3' style="min-width: 280px;max-width: 280px;" class='pa-1'>
    <v-card min-width="280" class="fill-height">
        <v-card-title>
            Helm
        </v-card-title>
        <v-card-text>
            <v-slider
                v-model="engine.throttle"
                :color="`rgb(${engine.throttle*2.55}, 0, 0)`"
                track-color="black"
                label="Thrust"
            ></v-slider>
            <div class="helm-rcs-buttons">
                <v-row>
                    <v-col>
                        <v-btn dark color="indigo" @click="tlClick">
                            <v-icon>mdi-arrow-top-left</v-icon>
                        </v-btn>
                    </v-col>
                    <v-col>
                        <v-btn dark color="indigo" @click="tClick">
                            <v-icon>mdi-arrow-up</v-icon>
                        </v-btn>
                    </v-col>
                    <v-col>
                        <v-btn dark color="indigo" @click="trClick">
                            <v-icon>mdi-arrow-top-right</v-icon>
                        </v-btn>
                    </v-col>
                </v-row>
                <v-row>
                    <v-col>
                        <v-btn dark color="indigo" @click="lClick">
                            <v-icon>mdi-arrow-left</v-icon>
                        </v-btn>
                    </v-col>
                    <v-col>
                        <v-btn dark @click="toggleEngine" :color="engine.on ? 'red' : 'purple darken-4'">
                            <v-icon>mdi-fire</v-icon>
                        </v-btn>
                    </v-col>
                    <v-col>
                        <v-btn dark color="indigo" @click="rClick">
                            <v-icon>mdi-arrow-right</v-icon>
                        </v-btn>
                    </v-col>
                </v-row>
                <v-row>
                    <v-col>
                        <v-btn dark color="indigo" @click="blClick">
                            <v-icon>mdi-arrow-bottom-left</v-icon>
                        </v-btn>
                    </v-col>
                    <v-col>
                        <v-btn dark color="indigo" @click="bClick">
                            <v-icon>mdi-arrow-down</v-icon>
                        </v-btn>
                    </v-col>
                    <v-col>
                        <v-btn dark color="indigo" @click="brClick">
                            <v-icon>mdi-arrow-bottom-right</v-icon>
                        </v-btn>
                    </v-col>
                </v-row>
            </div>
            <v-row>
                <v-col>
                    <v-btn dark color="indigo" class="full-width" @click="rotateLClick">
                        <v-icon>mdi-rotate-left</v-icon>
                    </v-btn>
                </v-col>
                <v-col>
                    <v-btn dark color="indigo" class="full-width" @click="rotateRClick">
                        <v-icon>mdi-rotate-right</v-icon>
                    </v-btn>
                </v-col>
            </v-row>
        </v-card-text>
    </v-card>
</v-col>
</template>

<script>
export default {
    name: "helm-system-card",
    methods: {
        tlClick () {
            this.$socket.emit("tlClick")
        },
        tClick () {
            this.$socket.emit("tClick")
        },
        trClick () {
            this.$socket.emit("trClick")
        },
        lClick () {
            this.$socket.emit("lClick")
        },
        rClick () {
            this.$socket.emit("rClick")
        },
        blClick () {
            this.$socket.emit("blClick")
        },
        bClick () {
            this.$socket.emit("bClick")
        },
        brClick () {
            this.$socket.emit("brClick")
        },
        rotateLClick () {
            this.$socket.emit("rotateLClick")
        },
        rotateRClick () {
            this.$socket.emit("rotateRClick")
        },
        toggleEngine () {
            this.engine.on = !this.engine.on
            this.$socket.emit("engine.onSet", this.engine.on)
        }
    },
    watch: {
        "engine.throttle"(newVal, val) {
            this.$socket.emit("engine.throttleSet", newVal)
        }
    },
    computed: {
        engine () {
            return this.$store.getters.engine
        }
    }
}
</script>

<style scoped lang="scss">
    .helm-rcs-buttons {
        button {
            height: 64px !important;
            width: 64px;
        }
    }
</style>